SystemOrganization addCategory: #'Xpf-Multipoint-Plugin'!

HandMorph subclass: #MultiPointerHandMorph
	instanceVariableNames: 'queue lastPosition mouseID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:04'!
createMorphicEvent: aPosition

	| newPosition evt |
	newPosition := self lastPosition + aPosition.
	newPosition := newPosition adhereTo: Display fullBoundingBox.
	evt := MouseMoveEvent new
		setType: #mouseMove
		startPoint: self lastPosition
		endPoint: newPosition
		trail: nil
		buttons: 0
		hand: self
		stamp: Time millisecondClockValue.
	self lastPosition: newPosition.
	^ evt! !

!MultiPointerHandMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/24/2009 13:51'!
enqueueEvent: aPoint

	self queue nextPut: (self createMorphicEvent: aPoint).! !

!MultiPointerHandMorph methodsFor: 'initialization' stamp: 'SR 4/24/2009 13:39'!
initialize

	super initialize.
	self queue: SharedQueue new.
	self lastPosition: 0 asPoint.	
! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
lastPosition

	^ lastPosition! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
lastPosition: anObject

	lastPosition := anObject! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
mouseID

	^ mouseID! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
mouseID: anObject

	mouseID := anObject! !

!MultiPointerHandMorph methodsFor: 'drawing' stamp: 'SR 4/24/2009 13:39'!
needsToBeDrawn

	^ true! !

!MultiPointerHandMorph methodsFor: 'event handling' stamp: 'SR 4/24/2009 13:43'!
processEvents
	"Play back the next event"

	[self queue isEmpty] whileFalse: [
		self handleEvent: self queue next].! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
queue

	^ queue! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
queue: anObject

	queue := anObject! !

Object subclass: #MultiPointer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

MultiPointer class
	instanceVariableNames: 'semaphore'!

MultiPointer class
	instanceVariableNames: 'semaphore'!

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:30'!
getPointerCount

	<primitive: 'primitiveMultiPointerCount' module: 'MultiPointerPlugin'>
	^ 42! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/23/2009 11:56'!
getPointerCurrentPoint: aPointerID

	<primitive: 'primitiveMultiPointerCurrentPoint' module: 'MultiPointerPlugin'>
	^ 42 asPoint! !

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'mig 4/22/2009 17:34'!
getPointerName: aPointerID

	| pointerName |
	pointerName := self pvtGetPointerName: aPointerID.
	^ pointerName truncateTo: (pointerName 
			indexOf: (Character value: 0) 
			startingAt: 0 
			ifAbsent: [pointerName size + 1]) - 1! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 4/22/2009 16:56'!
pvtGetPointerName: aPointerID

	<primitive: 'primitiveMultiPointerName' module: 'MultiPointerPlugin'>
	^ 'Pointing Device'! !

!MultiPointer class methodsFor: 'system startup' stamp: 'SR 4/23/2009 14:41'!
registerSemaphore

	| semaIndex |
	semaIndex := Smalltalk registerExternalObject: self semaphore.
	self setPointerSemaphoreHandle: semaIndex.! !

!MultiPointer class methodsFor: 'accessing' stamp: 'SR 4/23/2009 14:41'!
semaphore

	semaphore ifNil: [self semaphore: Semaphore new].
	^ semaphore! !

!MultiPointer class methodsFor: 'accessing' stamp: 'SR 4/23/2009 14:40'!
semaphore: anObject

	semaphore := anObject! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/23/2009 14:20'!
setPointerSemaphoreHandle: aSemaIndex

	<primitive: 'primitiveMultiPointerSemaphoreHandle' module: 'MultiPointerPlugin'>! !

!MultiPointer class methodsFor: 'system startup' stamp: 'SR 4/23/2009 14:41'!
unregisterSemaphore

	| |
	self setPointerSemaphoreHandle: 0.
	Smalltalk unregisterExternalObject: self semaphore.
	self semaphore: nil.
! !

Object subclass: #MultiPointerManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

MultiPointerManager class
	instanceVariableNames: 'handMorphs movementProcess'!

MultiPointerManager class
	instanceVariableNames: 'handMorphs movementProcess'!

!MultiPointerManager class methodsFor: 'as yet unclassified' stamp: 'SR 4/24/2009 14:55'!
createHandMorphForMouse: aMouseID

	^ self handMorphs
			detect: [:each | each mouseID = aMouseID]
			ifNone: [ | m |
				m := MultiPointerHandMorph new mouseID: aMouseID.
				self handMorphs add: m.
			]! !

!MultiPointerManager class methodsFor: 'as yet unclassified' stamp: 'SR 4/24/2009 14:55'!
destroyHandMorphForMouse: aMouseID

	| m |
	m := self handMorphs detect: [:each | each mouseID = aMouseID].
	self handMorphs remove: m.
			! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
handMorphs

	^ handMorphs! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
handMorphs: anObject

	handMorphs := anObject! !

!MultiPointerManager class methodsFor: 'class initialization' stamp: 'SR 4/24/2009 14:32'!
initialize

	super initialize.
	self handMorphs: OrderedCollection new.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:51'!
movementProcess

	^ movementProcess! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:51'!
movementProcess: anObject

	movementProcess := anObject! !

!MultiPointerManager class methodsFor: 'system startup' stamp: 'SR 4/24/2009 14:30'!
shutDown: aboutToQuit 

	MultiPointer unregisterSemaphore.
	super shutDown: aboutToQuit.! !

!MultiPointerManager class methodsFor: 'as yet unclassified' stamp: 'SR 4/24/2009 14:53'!
startMoving

	self handMorphs do: [:each | 
		World addHand: each.
		MultiPointer getPointerCurrentPoint: each mouseID].
	
	self movementProcess: [
		[
			MultiPointer semaphore wait.
			self handMorphs do: [:each |
				each enqueueEvent: (MultiPointer getPointerCurrentPoint: each mouseID)]
		] repeat
	] fork.! !

!MultiPointerManager class methodsFor: 'system startup' stamp: 'SR 4/24/2009 14:30'!
startUp: aboutToQuit 

	MultiPointer registerSemaphore.
	super startUp: aboutToQuit.! !

!MultiPointerManager class methodsFor: 'as yet unclassified' stamp: 'SR 4/24/2009 14:54'!
stopMoving

	self movementProcess terminate.
	self handMorphs do: [:each | 
		World removeHand: each].
! !

Object subclass: #MultiPointerState
	instanceVariableNames: 'x y buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
buttons

	^ buttons! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
buttons: anObject

	buttons := anObject! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
x

	^ x! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
x: anObject

	x := anObject! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
y

	^ y! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
y: anObject

	y := anObject! !

SmartSyntaxInterpreterPlugin subclass: #MultiPointerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:07'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^ true! !

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:08'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^ true! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
initialiseModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerInit()' inSmalltalk:[true]! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 13:23'!
moduleUnloaded: aModuleName 
	"The module with the given name was just unloaded. 
	Make sure we have no dangling references."
	self export: true.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:28'!
primitiveMultiPointerCount

	| r |
	self primitive: 'primitiveMultiPointerCount'.
	r := self cCode:' multiPointerCount()'.
	^r asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/28/2009 21:23'!
primitiveMultiPointerCurrentPoint: aPointerID

	| oop inputX inputY |
	self primitive:'primitiveMultiPointerCurrentPoint'.
	self var: 'inputX' declareC: 'int inputX'.
	self var: 'inputY' declareC: 'int inputY'.
	self cCode: 'multiPointerCurrentPoint(interpreterProxy->integerValueOf(aPointerID), &inputX, &inputY)'.
	oop := interpreterProxy makePointwithxValue: inputX yValue: inputY.
	^ oop! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/24/2009 15:44'!
primitiveMultiPointerCurrentState: aPointerID

	| oop  inputX inputY buttons |
	self primitive:'primitiveMultiPointerCurrentState'.
	self var: 'inputX' declareC: 'int inputX'.
	self var: 'inputY' declareC: 'int inputY'.
	self var: 'buttons' declareC: 'int inputY'.
	self cCode: 'multiPointerCurrentState(interpreterProxy->integerValueOf(aPointerID), &inputX, &inputY, &buttons)'.
	oop := interpreterProxy instantiateClass: MultiPointerState indexableSize: 0.
	interpreterProxy storeInteger: 0 ofObject: oop withValue: inputX.
	interpreterProxy storeInteger: 1 ofObject: oop withValue: inputY.
	interpreterProxy storeInteger: 2 ofObject: oop withValue: buttons.
	^ oop! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/23/2009 14:24'!
primitiveMultiPointerName: aPointerID

	| oop length buffer |
	self primitive:'primitiveMultiPointerName'.
	length := self multiPointerNameLength:  (interpreterProxy integerValueOf: aPointerID).
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	buffer :=  interpreterProxy firstIndexableField: oop.
	self cCode: 'multiPointerName(interpreterProxy->integerValueOf(aPointerID), interpreterProxy->integerValueOf(length), buffer)'.
	^ oop! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/23/2009 14:23'!
primitiveMultiPointerSemaphoreHandle: aSemaIndex

	| |
	self primitive:'primitiveMultiPointerSemaphoreHandle' parameters: #(#SmallInteger).
	self multiPointerSetSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
shutdownModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerShutdown()' inSmalltalk:[true]! !
MultiPointerManager initialize!
